package cz.muni.consumption

import android.os.Bundle
import android.view.MenuItem
import androidx.appcompat.app.AppCompatActivity
import com.google.android.material.tabs.TabLayoutMediator
import cz.muni.consumption.databinding.ActivityRoundUneditableBinding
import cz.muni.consumption.ui.playSession.round.ViewPagerUneditableAdapter

class RoundUneditableActivity : AppCompatActivity() {
    lateinit var binding: ActivityRoundUneditableBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        binding = ActivityRoundUneditableBinding.inflate(layoutInflater)
        supportActionBar?.setDisplayHomeAsUpEnabled(true)
        setContentView(binding.root)

        val viewPager = binding.viewPager
        val tabLayout = binding.tabLayout

        val adapter = ViewPagerUneditableAdapter(supportFragmentManager, lifecycle)
        viewPager.adapter = adapter

        TabLayoutMediator(tabLayout, viewPager) { tab, position ->
            tab.text = "Round " + adapter.getRoundNumber(position)
        }.attach()

        intent.getStringExtra("playId")?.let { it1 -> adapter.addExistingRoundFragments(it1) }
    }

    override fun onOptionsItemSelected(item: MenuItem): Boolean {
        if (item.itemId == android.R.id.home) {
            onBackPressedDispatcher.onBackPressed()
            return true
        }
        return super.onOptionsItemSelected(item)
    }
}