package cz.muni.consumption.data

import android.os.Parcelable
import kotlinx.parcelize.Parcelize

@Parcelize
data class Game(
    var id: String,
    var name: String,
    var description: String,
    var cardType: String,
    var rules: String,
    var maxPlayers: Int,
    var minPlayers: Int,
    var maxTime: Int,
    var minTime: Int,
    var scoreSubtract: Boolean,
    var scoreValue: Int
) : Parcelable {

    constructor() : this(
        id = "0",
        name = "",
        description = "",
        cardType = "",
        rules = "",
        maxPlayers = 0,
        minPlayers = 0,
        maxTime = 0,
        minTime = 0,
        scoreSubtract = false,
        scoreValue = 0
    )

    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (javaClass != other?.javaClass) return false

        other as Game

        if (name != other.name) return false
        if (description != other.description) return false
        if (cardType != other.cardType) return false
        if (rules != other.rules) return false
        if (maxPlayers != other.maxPlayers) return false
        if (minPlayers != other.minPlayers) return false
        if (maxTime != other.maxTime) return false
        if (minTime != other.minTime) return false
        if (scoreSubtract != other.scoreSubtract) return false
        if (scoreValue != other.scoreValue) return false
        return true
    }

    override fun hashCode(): Int {
        var result = description.hashCode()
        result = 31 * result + cardType.hashCode()
        result = 31 * result + rules.hashCode()
        result = 31 * result + maxPlayers
        result = 31 * result + minPlayers
        result = 31 * result + maxTime
        result = 31 * result + minTime
//        result = 31 * result + scoreSubtract.hashCode() //TODO
//        result = 31 * result + scoreValue
        return result
    }
}