package cz.muni.consumption.data

import android.os.Parcelable
import kotlinx.parcelize.Parcelize

@Parcelize
data class InitPlay(
    var id: String,
    val gameId: String,
    val gameName: String,
    var players: MutableMap<String, Player>,
    var playId: String
) : Parcelable {

    constructor() : this(
        id = "0",
        gameId = "0",
        gameName = "",
        playId = "",
        players = mutableMapOf()
    )

    constructor(gameId: String, gameName: String) : this(
        id = "",
        gameId = gameId,
        gameName = gameName,
        playId = "",
        players = mutableMapOf()
    )

    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (javaClass != other?.javaClass) return false

        other as InitPlay

        if (gameId != other.gameId) return false
        if (gameName != other.gameName) return false
        if (players != other.players) return false

        return true
    }

    override fun hashCode(): Int {
        var result = gameId.hashCode()
        result = 31 * result + gameName.hashCode()
        result = 31 * result + players.hashCode()
        return result
    }

}