package cz.muni.consumption.ui.playSession.round

import android.os.Bundle
import android.view.*
import android.widget.Toast
import androidx.fragment.app.Fragment
import androidx.recyclerview.widget.LinearLayoutManager
import cz.muni.consumption.data.RoundScores
import cz.muni.consumption.database.FirebaseProxy
import cz.muni.consumption.databinding.FragmentRoundUneditableBinding

class RoundUneditableFragment : Fragment() {
    private lateinit var binding: FragmentRoundUneditableBinding

    private var playId: String = ""
    private var roundNumber: Int = 0

    fun setParameters(aPlayId: String, aRoundNum: Int) {
        playId = aPlayId
        roundNumber = aRoundNum
    }


    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        binding = FragmentRoundUneditableBinding.inflate(layoutInflater, container, false)
        return binding.root
    }

    private val roundUneditableAdapter: RoundUneditableAdapter by lazy {
        RoundUneditableAdapter(
            onItemClick = {
            }
        )
    }

    override fun onCreateOptionsMenu(menu: Menu, inflater: MenuInflater) {
        menu.clear()
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        setHasOptionsMenu(true)

        binding.scoreRecyclerView.layoutManager = LinearLayoutManager(context)
        binding.scoreRecyclerView.adapter = roundUneditableAdapter
    }

    private fun refreshList() {

        FirebaseProxy.getPlayList(playId,
            success = { plays ->
                val play = plays[0]
                val roundScores = mutableListOf<RoundScores>()
                for (i in 0 until play.players.size) {
                    roundScores.add(RoundScores(roundNumber, i, play))
                }
                //roundUneditableAdapter.submitList(null);
                roundUneditableAdapter.submitList(roundScores)
            },
            fail = {
                Toast.makeText(context, "Server error", Toast.LENGTH_SHORT).show()
            }
        )

    }

    override fun onResume() {
        super.onResume()
        refreshList()
    }
}