package cz.muni.consumption.ui.playSession.round

import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentManager
import androidx.lifecycle.Lifecycle
import androidx.viewpager2.adapter.FragmentStateAdapter
import cz.muni.consumption.database.FirebaseProxy

//https://medium.com/busoft/how-to-use-viewpager2-with-tablayout-in-android-eaf5b810ef7c


class ViewPagerUneditableAdapter(fragmentManager: FragmentManager, lifecycle: Lifecycle) :
    FragmentStateAdapter(fragmentManager, lifecycle) {
    private val mFragments: MutableList<Fragment> = ArrayList()
    private val mFragmentNumbers: MutableList<Int> = ArrayList()

    override fun getItemCount(): Int {
        return mFragments.size
    }

    fun getRoundNumber(position: Int): Int {
        if (position < mFragmentNumbers.size) {
            return mFragmentNumbers[position]
        }
        return 0
    }


    fun addExistingRoundFragments(playId: String) {
        FirebaseProxy.getPlayList(playId,
            success = { plays ->
                val play = plays[0]
                if (mFragments.size < play.rounds.size) {
                    for (i in mFragments.size until play.rounds.size) {
                        val fragment = RoundUneditableFragment()
                        if (mFragmentNumbers.size == 0) {
                            mFragmentNumbers.add(0)
                        } else {
                            mFragmentNumbers.add(mFragmentNumbers.last() + 1)
                        }

                        fragment.setParameters(playId, mFragmentNumbers.last())
                        mFragments.add(fragment)
                    }
                }

                notifyDataSetChanged()
            },
            fail = {
                //Toast.makeText(context, "Server error", Toast.LENGTH_SHORT).show()
            }
        )
    }

    fun deleteFragment(position: Int) {
        mFragments.removeAt(position)
        mFragmentNumbers.removeAt(position)
        notifyDataSetChanged()
    }

    override fun createFragment(position: Int): Fragment {
        return mFragments[position]
    }
}